#include <QtCore/QString>
#include <QDialog>

#include "PublisherSelectDialog.h"
#include "PublisherSelectDialog.moc"

PublisherSelectDialog::PublisherSelectDialog(QDialog *parent)
{
	setupUi(this);
	retranslateUi2();
}

PublisherSelectDialog::~PublisherSelectDialog()
{
	if(m_pEnumPublisherInfo)
	{
		delete[] m_pEnumPublisherInfo;
	}
}

PP100_ENUM_PUBLISHER_INFO PublisherSelectDialog::getSelectPublisher()
{
	return m_pEnumPublisherInfo[comboBox->currentIndex()];
}

void PublisherSelectDialog::retranslateUi2()
{
	// Enumerate PP-100 Series.
	long nRet = g_Api.PP100_EnumPublishers(g_Api.ulHandle, m_pEnumPublisherInfo, &m_ulEnumPublisherInfoNum);
	if(PP100API_MORE_ITEMS == nRet)
	{
		while(PP100API_MORE_ITEMS == nRet)
		{
			m_pEnumPublisherInfo = new PP100_ENUM_PUBLISHER_INFO[m_ulEnumPublisherInfoNum];
			if(NULL == m_pEnumPublisherInfo)
			{
				printf("Allocating new memory failed.\n");
				break;
			}
			else
			{
				memset(m_pEnumPublisherInfo , 0 , sizeof(PP100_ENUM_PUBLISHER_INFO) * m_ulEnumPublisherInfoNum);
				nRet = g_Api.PP100_EnumPublishers(g_Api.ulHandle, m_pEnumPublisherInfo, &m_ulEnumPublisherInfoNum);
				if(PP100API_SUCCESS == nRet)
				{
					comboBox->clear();
					for(unsigned long nCnt = 0; nCnt < m_ulEnumPublisherInfoNum; ++nCnt)
					{
						// Add Publisher name to combo box
						comboBox->addItem(m_pEnumPublisherInfo[nCnt].pPublisherName);
					}
				}
			}
		}
	}
	else
	{
		printf("Enumerating to PC that TDBridge is running failed.\n");
	}
}
